/*

Copyright (c) 2016 Roberto Mojica Diaz

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all
copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
SOFTWARE.
*/

const int DB=5;
const int DC=6;
const int DD=7;
const int DA=8;
const int LEDdp=13;
const int SL1=10;
const int SL2=11;
const int SL3=14;
const int inPinUp=9;
const int inPinDown=12;
int channel = 1;
int buttonUpState = 0;
int buttonDownState = 0;
int prevBtnUp = HIGH;
int prevBtnDwn = HIGH;
unsigned long lastBtnUp = 0;
unsigned long lastBtnDwn = 0;
int transInt = 250;
int chanPolling = 5000;
unsigned long chanPrevPoll = 0;



void setup()
{
 Serial.begin(9600);
 pinMode(inPinUp, INPUT);
 pinMode(inPinDown, INPUT);
 pinMode(DA,OUTPUT);
 pinMode(DB,OUTPUT);
 pinMode(DC,OUTPUT);
 pinMode(DD,OUTPUT);
 pinMode(LEDdp,OUTPUT);
 pinMode(SL1,OUTPUT);
 pinMode(SL2,OUTPUT);
 pinMode(SL3,OUTPUT);



}

void channelFunction()
{
 switch (channel)
     {
     case 1:
       Serial.println("+TSC01");
       Serial.println("+TSC?");
       digitalWrite(DB,LOW);
       digitalWrite(DC,LOW);
       digitalWrite(DD,HIGH);
       digitalWrite(DA,LOW);
       digitalWrite(LEDdp,HIGH);
       digitalWrite(SL1,HIGH);
       digitalWrite(SL2,LOW);
       digitalWrite(SL3,HIGH);
       break;
     case 2:
       Serial.println("+TSC02");
       Serial.println("+TSC?");
       digitalWrite(DB,LOW);
       digitalWrite(DC,LOW);
       digitalWrite(DD,LOW);
       digitalWrite(DA,LOW);
       digitalWrite(LEDdp,LOW);
       digitalWrite(SL1,LOW);
       digitalWrite(SL2,LOW);
       digitalWrite(SL3,LOW);
       break;
     case 3:
       Serial.println("+TSC03");
       Serial.println("+TSC?");
       digitalWrite(DB,LOW);
       digitalWrite(DC,LOW);
       digitalWrite(DD,LOW);
       digitalWrite(DA,HIGH);
       digitalWrite(LEDdp,LOW);
       digitalWrite(SL1,HIGH);
       digitalWrite(SL2,LOW);
       digitalWrite(SL3,LOW);
        break;
     case 4:
       Serial.println("+TSC04");
       Serial.println("+TSC?");
       digitalWrite(DB,HIGH);
       digitalWrite(DC,LOW);
       digitalWrite(DD,LOW);
       digitalWrite(DA,LOW);
       digitalWrite(LEDdp,LOW);
       digitalWrite(SL1,HIGH);
       digitalWrite(SL2,HIGH);
       digitalWrite(SL3,LOW);
       break;
     case 5:
       Serial.println("+TSC05");
       Serial.println("+TSC?");
       digitalWrite(DB,HIGH);
       digitalWrite(DC,LOW);
       digitalWrite(DD,LOW);
       digitalWrite(DA,HIGH);
       digitalWrite(LEDdp,LOW);
       digitalWrite(SL1,LOW);
       digitalWrite(SL2,HIGH);
       digitalWrite(SL3,LOW);
       break;
     case 6:
       Serial.println("+TSC06");
       Serial.println("+TSC?");
       digitalWrite(DB,LOW);
       digitalWrite(DC,HIGH);
       digitalWrite(DD,LOW);
       digitalWrite(DA,LOW);
       digitalWrite(LEDdp,LOW);
       digitalWrite(SL1,LOW);
       digitalWrite(SL2,LOW);
       digitalWrite(SL3,LOW);
       break;
     case 7:
       Serial.println("+TSC07");
       Serial.println("+TSC?");
       digitalWrite(DB,LOW);
       digitalWrite(DC,HIGH);
       digitalWrite(DD,LOW);
       digitalWrite(DA,HIGH);
       digitalWrite(LEDdp,HIGH);
       digitalWrite(SL1,LOW);
       digitalWrite(SL2,LOW);
       digitalWrite(SL3,HIGH);
       break;

      }
}
void loop()

{
 buttonUpState = digitalRead(inPinUp);
 buttonDownState = digitalRead(inPinDown);
 if (buttonUpState == HIGH && prevBtnUp == LOW)
 {
   if (millis() - lastBtnUp > transInt)
   {
   channel++;
   if (channel > 7)
     {
     channel = 7;
     }
   lastBtnUp = millis();
   channelFunction();
   }
  }
 prevBtnUp = buttonUpState;

 if (buttonDownState == HIGH && prevBtnDwn == LOW)
 {
   if (millis() - lastBtnDwn > transInt)
   {
   channel--;
   if (channel < 1)
   {
     channel = 1;
   }
   lastBtnDwn = millis();
    channelFunction();
 }
 }
 prevBtnDwn = buttonDownState;

     if (millis() - chanPrevPoll > chanPolling)
 {
   chanPrevPoll = millis();
   Serial.println("+TSC?");
 }

}
